function varargout = predictRegression_GUI(varargin)
% PREDICTREGRESSION_GUI MATLAB code for predictRegression_GUI.fig
%      PREDICTREGRESSION_GUI, by itself, creates a new PREDICTREGRESSION_GUI or raises the existing
%      singleton*.
%
%      H = PREDICTREGRESSION_GUI returns the handle to a new PREDICTREGRESSION_GUI or the handle to
%      the existing singleton*.
%
%      PREDICTREGRESSION_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PREDICTREGRESSION_GUI.M with the given input arguments.
%
%      PREDICTREGRESSION_GUI('Property','Value',...) creates a new PREDICTREGRESSION_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before predictRegression_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to predictRegression_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help predictRegression_GUI

% Last Modified by GUIDE v2.5 03-Aug-2016 22:50:16

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @predictRegression_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @predictRegression_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before predictRegression_GUI is made visible.
function predictRegression_GUI_OpeningFcn(hObject, ~, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to predictRegression_GUI (see VARARGIN)

% Choose default command line output for predictRegression_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes predictRegression_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

global CommonHandles;

set(handles.plateSelectorList,'String',CommonHandles.PlatesNames);

rowNum = CommonHandles.PlateTypeInfo{CommonHandles.WellType}.row;
colNum = CommonHandles.PlateTypeInfo{CommonHandles.WellType}.col;

rowmax = (char(rowNum+'A'-1));
rowString = cellstr(('A':rowmax)')';
set(handles.rowSelectorPopup,'String',rowString);

colString = strsplit(num2str(1:colNum,'%02d '),' ');
set(handles.colSelectorPopup,'String',colString);



% --- Outputs from this function are returned to the command line.
function varargout = predictRegression_GUI_OutputFcn(~, ~, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function resolutionEdit_Callback(~, ~, ~)
% hObject    handle to resolutionEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of resolutionEdit as text
%        str2double(get(hObject,'String')) returns contents of resolutionEdit as a double


% --- Executes during object creation, after setting all properties.
function resolutionEdit_CreateFcn(hObject, ~, ~)
% hObject    handle to resolutionEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in predictButton.
function predictButton_Callback(~, ~, handles)
% hObject    handle to predictButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%
% This functions reads out the necessary information from the GUIs controls
% and generates the reports to the project folder.

global CommonHandles;
uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

if strcmp(CommonHandles.SelectedClassifier,'OneClassClassifier')
    warndlg('Train a classifier after using ''Phenotype finder'' module!','Classifier error');
elseif ~isnumeric(CommonHandles.SelectedClassifier)
    warndlg('Chosen classifier error!','Classifier error');
else           
    %check for the existance of the SALT model. If not, then we train a
    %model.
    screensize = get(0,'Screensize');
    if ~isfield(CommonHandles.SALT,'model') || isempty(CommonHandles.SALT.model)
        iD = dialog('Name','Missing classifer','Position',[screensize(3)/2-180, screensize(4)/2-30,360,60]);
        uicontrol('Parent',iD,'Style','text','Units','Pixels','Position',[10 20 340 20],'String','Train a classifier...');
        CommonHandles = trainClassifier(CommonHandles);
        if ishandle(iD)
            close(iD);
        end
    end
    if isfield(CommonHandles.SALT,'model') && ~isempty(CommonHandles.SALT.model)
        if isfield(CommonHandles.RegressionPlane{idx},'Predictor') && ~isempty(CommonHandles.RegressionPlane{idx}.Predictor)
            %HERE STARTS THE SHOW ;)
            selectedPlateNumbers = get(handles.plateSelectorList,'Value');
            %make result folder
            baseFolder = get(handles.resultFolderEdit,'String');            
            if ~exist([CommonHandles.DirName filesep baseFolder],'dir')
                mkdir([CommonHandles.DirName filesep baseFolder]);
                mkdir([CommonHandles.DirName filesep baseFolder filesep CommonHandles.ImageFolder]);
                mkdir([CommonHandles.DirName filesep baseFolder filesep CommonHandles.MetaDataFolder]);                
                mkdir([CommonHandles.DirName filesep baseFolder filesep CommonHandles.OriginalImageFolder]);
            end
            %check for HTML requirement
            html = get(handles.htmlCheckBox,'Value');
            thumbnail = get(handles.thumbnailCheckBox,'Value');
            resolution = str2double(get(handles.resolutionEdit,'String'));
            if isnan(resolution)
                errordlg('The resolution has to be a number!','Parameter type error');
                return;
            elseif rem(resolution,1)~=0
                errordlg('The resolution has to be integer','Parameter type error');
                return;
            end
            for i=convert2RowVector(selectedPlateNumbers)
                %generate for this plate                
                col = get(handles.colSelectorPopup,'Value');
                row = get(handles.rowSelectorPopup,'Value');
                regressionReportForPlate(i,html,thumbnail,resolution,baseFolder,idx,row,col);
            end            
            if ishandle(handles.figure1)
                close(handles.figure1);
            end               
            
        else
            warndlg('Train a regressor to predict plates.');
        end                    
    else
        warndlg('Couldn''t train classifier.','Classifier error');
    end
end




% --- Executes on selection change in plateSelectorList.
function plateSelectorList_Callback(~, ~, ~)
% hObject    handle to plateSelectorList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns plateSelectorList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plateSelectorList


% --- Executes during object creation, after setting all properties.
function plateSelectorList_CreateFcn(hObject, ~, ~)
% hObject    handle to plateSelectorList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function resultFolderEdit_Callback(~, ~, ~)
% hObject    handle to resultFolderEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of resultFolderEdit as text
%        str2double(get(hObject,'String')) returns contents of resultFolderEdit as a double


% --- Executes during object creation, after setting all properties.
function resultFolderEdit_CreateFcn(hObject, ~, ~)
% hObject    handle to resultFolderEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in htmlCheckBox.
function htmlCheckBox_Callback(~, ~, ~)
% hObject    handle to htmlCheckBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of htmlCheckBox


% --- Executes on button press in thumbnailCheckBox.
function thumbnailCheckBox_Callback(~, ~, ~)
% hObject    handle to thumbnailCheckBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of thumbnailCheckBox


% --- Executes on selection change in rowSelectorPopup.
function rowSelectorPopup_Callback(~, ~, ~)
% hObject    handle to rowSelectorPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns rowSelectorPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from rowSelectorPopup


% --- Executes during object creation, after setting all properties.
function rowSelectorPopup_CreateFcn(hObject, ~, ~)
% hObject    handle to rowSelectorPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in colSelectorPopup.
function colSelectorPopup_Callback(~, ~, ~)
% hObject    handle to colSelectorPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns colSelectorPopup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from colSelectorPopup


% --- Executes during object creation, after setting all properties.
function colSelectorPopup_CreateFcn(hObject, ~, ~)
% hObject    handle to colSelectorPopup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
