function varargout = regressionPlane(varargin)
% REGRESSIONPLANE M-file for regressionPlane.fig
%      REGRESSIONPLANE, by itself, creates a new REGRESSIONPLANE or raises the existing
%      singleton*.
%
%      H = REGRESSIONPLANE returns the handle to a new REGRESSIONPLANE or the handle to
%      the existing singleton*.
%
%      REGRESSIONPLANE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in REGRESSIONPLANE.M with the given input arguments.
%
%      REGRESSIONPLANE('Property','Value',...) creates a new REGRESSIONPLANE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before regressionPlane_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to regressionPlane_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help regressionPlane

% Last Modified by GUIDE v2.5 11-Aug-2016 19:49:27

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @regressionPlane_OpeningFcn, ...
                   'gui_OutputFcn',  @regressionPlane_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before regressionPlane is made visible.
function regressionPlane_OpeningFcn(hObject, ~, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to regressionPlane (see VARARGIN)

% Choose default command line output for regressionPlane
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes regressionPlane wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% GLOBAL variables and global 'constants'.
global CommonHandles;
global ghandles;
ghandles = handles;

%get the index of the current reg class.
uData = get(handles.figure1,'UserData');
idx = uData.classIndex;
idInTrainingSet = uData.idInTrainingSet;
CommonHandles.RegressionPlane{idx}.initialApparentPictureSize = 100;
CommonHandles.RegressionPlane{idx}.mainFigureHandle = hObject;

% newObject is a boolean to show whether we're putting down now a cell to
% distinguish between selecting cell and putting down new cell with right
% click.
if uData.prediction == 0
    CommonHandles.RegressionPlane{idx}.newObject = 1;
else
    CommonHandles.RegressionPlane{idx}.newObject = 0;
end

CommonHandles.RegressionPlane{idx}.selectedObject = idInTrainingSet;
for i=1:length(CommonHandles.RegressionPlane)
    if isfield(CommonHandles.RegressionPlane{i},'selectedAxes') && ~isempty(CommonHandles.RegressionPlane{i}.selectedAxes) &&  ishandle(CommonHandles.RegressionPlane{i}.selectedAxes)
        cla(CommonHandles.RegressionPlane{i}.selectedAxes);
    end
end
CommonHandles.RegressionPlane{idx}.selectedAxes = [];

if get(handles.checkbox1,'Value')
    CommonHandles.RegressionPlane{idx}.showGrid = 1;
else
    CommonHandles.RegressionPlane{idx}.showGrid = -1;
end
if get(handles.checkbox3,'Value')
    CommonHandles.RegressionPlane{idx}.gridOnTheTop = 1;
else
    CommonHandles.RegressionPlane{idx}.gridOnTheTop = -1;
end

if strcmp(get(handles.adaptiveCellSize,'State'),'off')
    CommonHandles.RegressionPlane{idx}.adaptiveCellSize = 0;
else
    CommonHandles.RegressionPlane{idx}.adaptiveCellSize = 1;
end



%Init other CommonHandles fields
fieldsToCheck = {...    
    {'dragging','[]'},...
    {'orPos','[]'},...
    {'mapDragged','[]'},...
    {'startOfAdaptionCellSize','[]'},...
    {'apparentPictureSize','CommonHandles.RegressionPlane{idx}.initialApparentPictureSize'},...
    {'XBounds','[0 1000]'},...
    {'YBounds','[0 1000]'},...
    {'adaptiveCellSize','0'},...
    {'gridDistance','10'},...
    };
for i=1:length(fieldsToCheck)
    if ~isfield(CommonHandles.RegressionPlane{idx},fieldsToCheck{i}{1})
        eval(['CommonHandles.RegressionPlane{idx}.' fieldsToCheck{i}{1} '=' fieldsToCheck{i}{2} ';']);
    end
end
    

placeItemsOnGUI(handles);

refreshSelectedObjectPictures(idx,uData);
%plotNavigationMap(idx);

%set(handles.axes11,'Ydir','reverse');
drawRegressionPlane(handles);


% --- Outputs from this function are returned to the command line.
function varargout = regressionPlane_OutputFcn(~, ~, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- drawRegressionPlane function draws out the required part of the
% regression plane.
% *************************************************************************
% *************************************************************************
function drawRegressionPlane(handles)
% XBounds is a 2 element array with lower (1st element) and upper (2nd
% element) bound to the x coordinates.
% YBounds is the same for y.
% CommonHandles and handles are used for communication.

%global variables
global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

% If an object will be selected then it'll be stored here.
selectedObject = CommonHandles.RegressionPlane{idx}.selectedObject;
if isfield(CommonHandles.RegressionPlane{idx},'selectedAxes')
    % Stored handle to the currently selected cell's axes
    selectedAxes = CommonHandles.RegressionPlane{idx}.selectedAxes;
end
%Boolean, storing the grid switch's status
showGrid = CommonHandles.RegressionPlane{idx}.showGrid;
%real, storing the grid unit
gridDistance = CommonHandles.RegressionPlane{idx}.gridDistance;
%boolean, indicating whether the grid is on the top of every cell or below
%them
gridOnTheTop = CommonHandles.RegressionPlane{idx}.gridOnTheTop;
%the currently apparent picture size
apparentPictureSize = CommonHandles.RegressionPlane{idx}.apparentPictureSize;

%regPlaneBoundaries: the pixel positions for the regression plane in the
%GUI. 1-2 coordinates are the x and y position for the left bottom corner,
%the 3-4 coordinates are the size in x and y direction.
regPlaneBoundaries = getpixelposition(handles.axes1);

plotNavigationMap(idx,uData);

XBounds = CommonHandles.RegressionPlane{idx}.XBounds;
YBounds = CommonHandles.RegressionPlane{idx}.YBounds;

%setting the scales to the right place
xlim(handles.axes11,[XBounds(1) XBounds(2)]);
ylim(handles.axes11,[YBounds(1) YBounds(2)]);
%push the scale axes to the back.
uistack(handles.axes11,'bottom');

if uData.prediction == 1
    indicesInThisClass = 1:length(uData.predictedIcons);
else
    %selecting the array of indices corresponding to this class    
    mergedClassVectors = reshape(cell2mat(CommonHandles.TrainingSet.Class),length(CommonHandles.Classes),[])';
    indicesInThisClass = find(mergedClassVectors(:,idx));
end

%the full DISPLAYED regression plane which can be seen on the screen.
fullRegPlane = zeros(regPlaneBoundaries(4),regPlaneBoundaries(3),3);
%According to the current bounds we fill the regression plane with a grid.
if (((showGrid+1)==2) && ((gridOnTheTop+1)~=2))

    XBU = ceil(XBounds(1)/gridDistance)*gridDistance;
    XBL = floor(XBounds(2)/gridDistance)*gridDistance;
    XLines = XBU:gridDistance:XBL;
    XLines = round( (XLines-XBounds(1))./ (XBounds(2)-XBounds(1)).*regPlaneBoundaries(3));
    fullRegPlane(:,XLines+1,:) = 100;

    YBU = ceil(YBounds(1)/gridDistance)*gridDistance;
    YBL = floor(YBounds(2)/gridDistance)*gridDistance;
    YLines = YBU:gridDistance:YBL;
    YLines = round( (YLines-YBounds(1))./ (YBounds(2)-YBounds(1)).*regPlaneBoundaries(4));
    fullRegPlane(regPlaneBoundaries(4)-YLines+1,:,:) = 100;
end

% This matrix is the same sized as the full regression plane which is the
% displayed regPlane. This whichObjectThere matrix contains the numbers of
% the object which is the most upper right now at the given pixel position.
% This helps us to determine if a right click was made that which cell is
% selected.
whichObjectThere = zeros(regPlaneBoundaries(4),regPlaneBoundaries(3));

if exist('selectedAxes','var') && ~isempty(selectedAxes) && ishandle(selectedAxes)
    cla(selectedAxes);    
end

%For every cell which has it's position on the regression plane.
for i=convert2RowVector(indicesInThisClass)       
    if isempty(i), break; end
        
    %select the information source
    if uData.prediction == 1
        classImgObj = uData.predictedIcons{i};
        centerX = uData.predictedPositions(1,i);
        centerY = uData.predictedPositions(2,i);
    else    
        %if the current ith cell doesn't have position or the regplane is empty
        if  ( ~isfield(CommonHandles.TrainingSet,'RegPos') || i>length(CommonHandles.TrainingSet.RegPos) || isempty(CommonHandles.TrainingSet.RegPos{i}) )          
            continue;
        end

        %get the picture from the classImgObjects field.
        classImgObj = getClassImgObjByTrainingSetID(CommonHandles,i,mergedClassVectors);

        %Getting out the regression position of the currentImage from
        %CommonHandles.
        centerX = CommonHandles.TrainingSet.RegPos{i}(1);
        centerY = CommonHandles.TrainingSet.RegPos{i}(2);    
    end
    
    [centerX,centerY] = regPlane2GUI(centerX,centerY,XBounds,YBounds,regPlaneBoundaries);   
    
    %Get the real size of picture which we'd like to display
    pictureDataXSize = size(classImgObj.Image,2);
    pictureDataYSize = size(classImgObj.Image,1);
    %The displayed image size initialization
    apparentPictureXSize = apparentPictureSize;
    apparentPictureYSize = apparentPictureSize;
    
    %Calculating the left upper corner position and round because we need
    %integer coordinates for the fullRegPlane image matrix
    leftUpperX = round(centerX - (apparentPictureXSize / 2));
    leftUpperY = round(centerY - (apparentPictureYSize / 2));
    
    %Transform to the GUI's coordinate system.    

    %If the current picture is in the required area then:
    if ((leftUpperX+apparentPictureXSize >= 0) && (leftUpperX <= regPlaneBoundaries(3)) && (leftUpperY+apparentPictureYSize >= 0) && (leftUpperY <= regPlaneBoundaries(4)))        
        %Handle the cases when the picture is out of the regression bound.
        
        %Initializing shown image boundaries.
        apparentStartX = leftUpperX;    
        apparentStartY = leftUpperY;    
        apparentEndX = floor(leftUpperX+apparentPictureXSize-1);    
        apparentEndY = floor(leftUpperY+apparentPictureYSize-1);    
        
        %Do the cuttings on the edge.
        if apparentStartX<1
           apparentStartX=1;
        end
        if apparentStartY<1
           apparentStartY=1;
        end
        if apparentEndX>regPlaneBoundaries(3)
           apparentEndX=regPlaneBoundaries(3);
        end
        if apparentEndY>regPlaneBoundaries(4)
           apparentEndY=regPlaneBoundaries(4);
        end
        
        %Calculating the start and end position for the picture pixels.
        XStartOfPicture = floor ( 1 + ((apparentStartX-leftUpperX)/apparentPictureXSize)*(pictureDataXSize-1) );
        YStartOfPicture = floor ( 1 + ((apparentStartY-leftUpperY)/apparentPictureYSize)*(pictureDataYSize-1) );
        XEndOfPicture = floor ( 1 + ((apparentEndX-leftUpperX)/apparentPictureXSize)*(pictureDataXSize-1)  );
        YEndOfPicture = floor ( 1 + ((apparentEndY-leftUpperY)/apparentPictureYSize)*(pictureDataYSize-1)  );
                      
        %Final check                   
        if XStartOfPicture < 1, XStartOfPicture = 1; end
        if YStartOfPicture < 1, YStartOfPicture = 1; end       
        
        %try   
        
        %Do the interpolation
        %Calculate the rescale rate
        tempXMult = (XEndOfPicture-XStartOfPicture)/(apparentEndX-apparentStartX+1);
        tempYMult = (YEndOfPicture-YStartOfPicture)/(apparentEndY-apparentStartY+1);
        %The offset which is between the picture's coordinate system
        %and the regression plane's coordinate system
        tempXOffset = (-apparentStartX*tempXMult) + XStartOfPicture;
        tempYOffset = (-apparentStartY*tempYMult) + YStartOfPicture;

        tempy=apparentStartY:apparentEndY;
        tempPictureY=ceil(tempy*tempYMult + tempYOffset);                
        tempx=apparentStartX:apparentEndX;
        tempPictureX=ceil(tempx*tempXMult + tempXOffset);            
        try
            if i~=selectedObject
                idxInTS = 0;
                if uData.prediction == 1
                    idxInTS = isInTrainingSet( uData.predictedIcons{i}.ImageName, uData.predictedIcons{i}.CellNumber, 0, CommonHandles);                
                end
                if strcmp(get(handles.ToolbarErrorVectors,'State'),'off') || idxInTS~=0
                    fullRegPlane(tempy,tempx,:) = classImgObj.Image(tempPictureY,tempPictureX,:);
                    if uData.prediction == 1 && idxInTS~=0 && ~isempty(tempx) && ~isempty(tempy);                    
                        fullRegPlane(tempy([1,end]),tempx,3) = 255;
                        fullRegPlane(tempy,tempx([1,end]),3) = 255;
                        fullRegPlane(tempy([1,end]),tempx([1,end]),3) = 255;
                    end
                    if strcmp(get(handles.ToolbarErrorVectors,'State'),'on') &&(idxInTS~=0 || (find(CommonHandles.TrainingSet.Class{idxInTS}) == uData.lastRegressionPlaneIdx))
                        groundTruthX = CommonHandles.TrainingSet.RegPos{idxInTS}(1);
                        groundTruthY = CommonHandles.TrainingSet.RegPos{idxInTS}(2);
                        [groundTruthX,groundTruthY] = regPlane2GUI(groundTruthX,groundTruthY,XBounds,YBounds,regPlaneBoundaries);
                        fullRegPlane = drawLineToPicture(fullRegPlane,round([groundTruthY,groundTruthX]),round([centerY,centerX]),[255,255,255]);                        
                    end
                    whichObjectThere(tempy,tempx) = i;
                end
            else                
                %Transform back leftBottomY as the axes' position is
                %counted as a picture.
                leftBottomY = regPlaneBoundaries(4) - apparentEndY;
                selectedAxes = axes('Units','pixels','Position',[apparentStartX+regPlaneBoundaries(1) leftBottomY+regPlaneBoundaries(2) (apparentEndX-apparentStartX) (apparentEndY-apparentStartY)]); %#ok<LAXES>
                selectedObjectPicture = classImgObj.Image(tempPictureY,tempPictureX,:);
                selectedObjectPicture([1,end],:,[2 3]) = 255;
                selectedObjectPicture(:,[1,end],[2 3]) = 255;
                selectedObjectPicture([1,end],[1,end],[2 3]) = 0;
                im = imshow(selectedObjectPicture,'Parent',selectedAxes);
                axis image;

                set(selectedAxes,'ButtonDownFcn',{@dragObject, handles});
                %the button doen fcn will not work until the image hit test is off
                set(im,'HitTest','off');

                %now set an image button doen fcn
                set(im,'ButtonDownFcn',{@dragObject, handles});

                %the image funtion will not fire until hit test is turned on
                set(im,'HitTest','on'); %now image button function will work
            end
        catch
            %There are sometimes (rarely) problem with index bounds, which
            %did not cause problem yet, and its easier to solve with
            %try-catch than with many-many ifs.
        end
    end      
end
   
if (((showGrid+1)==2) && ((gridOnTheTop+1)==2))

    XBU = ceil(XBounds(1)/gridDistance)*gridDistance;
    XBL = floor(XBounds(2)/gridDistance)*gridDistance;
    XLines = XBU:gridDistance:XBL;
    XLines = round( (XLines-XBounds(1))./ (XBounds(2)-XBounds(1)).*regPlaneBoundaries(3));
    fullRegPlane(:,XLines+1,:) = 100;

    YBU = ceil(YBounds(1)/gridDistance)*gridDistance;
    YBL = floor(YBounds(2)/gridDistance)*gridDistance;
    YLines = YBU:gridDistance:YBL;
    YLines = round( (YLines-YBounds(1))./ (YBounds(2)-YBounds(1)).*regPlaneBoundaries(4));
    fullRegPlane(regPlaneBoundaries(4)-YLines+1,:,:) = 100;
end

im = imshow(uint8(fullRegPlane),'Parent',handles.axes1);

%the button doen fcn will not work until the image hit test is off
set(im,'HitTest','off');

%now set an image button doen fcn
set(im,'ButtonDownFcn',@axes1_ButtonDownFcn);

%the image funtion will not fire until hit test is turned on
set(im,'HitTest','on'); %now image button function will work
        
       
CommonHandles.RegressionPlane{idx}.whichObjectThere = whichObjectThere;
CommonHandles.RegressionPlane{idx}.selectedAxes = selectedAxes;

% *************************************************************************
% *************************************************************************


%transforms the regressionPlane coordinate to the image coordinate system
function [centerX,centerY] = regPlane2GUI(centerX,centerY,XBounds,YBounds,regPlaneBoundaries)
    
%calculating the relative position to the displayed part of the regPlan     
distFromLowerXInRegPlane = centerX - XBounds(1);
distFromLowerYInRegPlane = centerY - YBounds(1);

%Transformation of the coordinates to the zoomed in space.
centerX = regPlaneBoundaries(3)*distFromLowerXInRegPlane/(XBounds(2)-XBounds(1));
centerY = regPlaneBoundaries(4)*distFromLowerYInRegPlane/(YBounds(2)-YBounds(1));
%Flip of Y because of different image and matrix indexing.
centerY = regPlaneBoundaries(4) - centerY;


%executes when dragging a selected object
function dragObject(hObject,~,handles)

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;
global CommonHandles;
CommonHandles.RegressionPlane{idx}.dragging = hObject;
CommonHandles.RegressionPlane{idx}.orPos = get(gcf,'CurrentPoint');      
set(gcf,'Pointer','hand');


% --- Executes on button press in pushbutton1, which is the Cross position
% button.
function pushbutton1_Callback(~, ~, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

selectedObject = CommonHandles.RegressionPlane{idx}.selectedObject;
if selectedObject
    selectedAxes = CommonHandles.RegressionPlane{idx}.selectedAxes;
    apparentPictureSize = CommonHandles.RegressionPlane{idx}.apparentPictureSize;
    newObject = CommonHandles.RegressionPlane{idx}.newObject;
    
    % ask for 1 mouse position
    newPos = ginput(1);
    regPlaneBoundaries = getpixelposition(handles.axes1);
    newPos(1) = newPos(1) + regPlaneBoundaries(1);
    newPos(2) = regPlaneBoundaries(2) + regPlaneBoundaries(4)- newPos(2);
    
    if isInRegPlane(newPos, regPlaneBoundaries);
        newPos = GUI2regPlane(newPos);
        if newObject
            CommonHandles.TrainingSet.RegPos{selectedObject} = [newPos(1) newPos(2)];
            newObject = 0;
        else
            CommonHandles.TrainingSet.RegPos{selectedObject} = newPos;
            set(selectedAxes,'Position',[newPos(1) newPos(2) apparentPictureSize apparentPictureSize]);
        end
        drawRegressionPlane(handles);
        refreshSelectedObjectInfoData;
    end
    
    CommonHandles.RegressionPlane{idx}.newObject = newObject;
end

% --- Executes on button press in pushbutton2. Regression errors. Not
% implemented yet.
function pushbutton2_Callback(~, ~, ~)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%% prediction errors


% --- Executes on scroll wheel click while the figure is in focus.
function figure1_WindowScrollWheelFcn(~, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  structure with the following fields (see FIGURE)
%	VerticalScrollCount: signed integer indicating direction and number of clicks
%	VerticalScrollAmount: number of lines scrolled for each click
% handles    structure with handles and user data (see GUIDATA)

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

global CommonHandles;
XBounds = CommonHandles.RegressionPlane{idx}.XBounds;
YBounds = CommonHandles.RegressionPlane{idx}.YBounds;
adaptiveCellSize = CommonHandles.RegressionPlane{idx}.adaptiveCellSize;
apparentPictureSize = CommonHandles.RegressionPlane{idx}.apparentPictureSize;
startOfAdaptionCellSize = CommonHandles.RegressionPlane{idx}.startOfAdaptionCellSize;

regPlaneBoundaries = getpixelposition(handles.axes1);
pos = get(gcf,'CurrentPoint');

if pos(1)>regPlaneBoundaries(1) && pos(1)<regPlaneBoundaries(1)+regPlaneBoundaries(3) && pos(2)> regPlaneBoundaries(2) && pos(2) < regPlaneBoundaries(2) + regPlaneBoundaries(4)        
    if eventdata.VerticalScrollCount>0 % we're zooming out        
        newSizeX = (XBounds(2) - XBounds(1))*1.2;
        newSizeY = (YBounds(2) - YBounds(1))*1.2;                
        if newSizeX>1000, newSizeX = 1000; end
        if newSizeY>1000, newSizeY = 1000; end 
        if (adaptiveCellSize && apparentPictureSize > startOfAdaptionCellSize)
            apparentPictureSize = apparentPictureSize.*0.8;                        
        end              
    else % we're zooming in
        newSizeX = (XBounds(2) - XBounds(1))*0.9;
        newSizeY = (YBounds(2) - YBounds(1))*0.9;                
        if adaptiveCellSize
            apparentPictureSize = apparentPictureSize.*1.1;
        end
    end    
    calcXYBounds(newSizeX, newSizeY, pos, regPlaneBoundaries,idx);
    drawRegressionPlane(handles);
        
end

CommonHandles.RegressionPlane{idx}.apparentPictureSize = apparentPictureSize;

%This util function modifies the global X and YBounds variables according to the
%new XY sizes and the center of the view which is stored in pos. We also
%need the regPlaneBoundaries variable which stores the position of the
%regression plane.
function calcXYBounds(newSizeX, newSizeY, pos, regPlaneBoundaries,idx)
    global CommonHandles;
    XBounds = CommonHandles.RegressionPlane{idx}.XBounds;
    YBounds = CommonHandles.RegressionPlane{idx}.YBounds;
    
    posXInRegPlane = (pos(1) - regPlaneBoundaries(1))/regPlaneBoundaries(3)*(XBounds(2) - XBounds(1))+XBounds(1);
    posYInRegPlane = (pos(2) - regPlaneBoundaries(2))/regPlaneBoundaries(4)*(YBounds(2) - YBounds(1))+YBounds(1);            
    
    XNewLower = posXInRegPlane - (pos(1)-regPlaneBoundaries(1))*newSizeX./regPlaneBoundaries(3);
    if XNewLower<0, XNewLower = 0; end    
    XNewUpper = XNewLower + newSizeX;
    if XNewUpper>1000, XNewUpper = 1000; end    
    YNewLower = posYInRegPlane - (pos(2)-regPlaneBoundaries(2))*newSizeY./regPlaneBoundaries(4);
    if YNewLower<0, YNewLower = 0; end    
    YNewUpper = YNewLower + newSizeY;        
    if YNewUpper>1000, YNewUpper = 1000; end
    
    CommonHandles.RegressionPlane{idx}.XBounds = [ XNewLower XNewUpper ];
    CommonHandles.RegressionPlane{idx}.YBounds = [ YNewLower YNewUpper ];

%This util function helps to convert back the points from the GUI to the
%regression plane.
function [newPos] = GUI2regPlane(newPos)
global ghandles;
global CommonHandles;
handles = ghandles;
uData = get(handles.figure1,'UserData');
idx = uData.classIndex;
XBounds = CommonHandles.RegressionPlane{idx}.XBounds;
YBounds = CommonHandles.RegressionPlane{idx}.YBounds;


regPlaneBoundaries = getpixelposition(handles.axes1); 

%Transform back from the displayed coordinate system to the stored one.
distFromXLowerInGUI = newPos(1) - regPlaneBoundaries(1);
distFromYLowerInGUI = newPos(2) - regPlaneBoundaries(2);

newPos(1) = distFromXLowerInGUI*(XBounds(2)-XBounds(1))/regPlaneBoundaries(3) + XBounds(1);
newPos(2) = distFromYLowerInGUI*(YBounds(2)-YBounds(1))/regPlaneBoundaries(4) +YBounds(1);

%This util function refreshes the pictures of the selectedCells.
function refreshSelectedObjectPictures(idx,uData)
global CommonHandles;
selectedObject = CommonHandles.RegressionPlane{idx}.selectedObject;
global ghandles;
handles = ghandles;

if selectedObject ~=0
    if uData.prediction == 1
        classImgObj = uData.predictedIcons{selectedObject};
    else
        classImgObj = getClassImgObjByTrainingSetID(CommonHandles,selectedObject);
    end
    imshow(classImgObj.Image,'Parent',handles.axes4);
    greenImage = zeros(size(classImgObj.Image,1),size(classImgObj.Image,2),3);
    greenImage(:,:,2) = classImgObj.Image(:,:,2);
    imshow(uint8(greenImage),'Parent',handles.axes5);        
else
    imshow(ones(100,100,3).*0.5,'Parent',handles.axes4);
    imshow(ones(100,100,3).*0.5,'Parent',handles.axes5);
end

%This util function refreshes the selectedObject's data like coordinates
%and cell number.
function refreshSelectedObjectInfoData()
global ghandles;
uData = get(ghandles.figure1,'UserData');
idx = uData.classIndex;
global CommonHandles;
selectedObject = CommonHandles.RegressionPlane{idx}.selectedObject;

if uData.prediction == 1 && selectedObject~=0
    selectedInTraining = isInTrainingSet( uData.predictedIcons{selectedObject}.ImageName, uData.predictedIcons{selectedObject}.CellNumber, 0, CommonHandles);
end

if (selectedObject == 0)
    set(ghandles.selectedCellText,'String', 'None');                
    set(ghandles.editXCoord,'String', 'N');                
    set(ghandles.editYCoord,'String', 'N');                
elseif (uData.prediction==1 && ~selectedInTraining)
    set(ghandles.selectedCellText,'String','NA');
    set(ghandles.editXCoord,'String',num2str(uData.predictedPositions(1,selectedObject)));
    set(ghandles.editYCoord,'String',num2str(uData.predictedPositions(2,selectedObject)));
else
    if uData.prediction==1
        selectedObject = selectedInTraining;
    end        
    set(ghandles.selectedCellText,'String', num2str(selectedObject));
    set(ghandles.editXCoord,'String', num2str(CommonHandles.TrainingSet.RegPos{selectedObject}(1)));                        
    set(ghandles.editYCoord,'String', num2str(CommonHandles.TrainingSet.RegPos{selectedObject}(2)));                    
end


%This util function will do the layout management for the regression plane.
%It should get the information from the regPlane main plot about
%resizements and then adjust the layout to that. We wish to make greater
%only the regression plane all the others should be maintained.
function placeItemsOnGUI(handles)

dimensions = get(gcf,'Position');
sizeX = dimensions(3);
sizeY = dimensions(4);

set(handles.axes1,'Units','pixels');
set(handles.axes1,'Position',[300, 50, sizeX-350, sizeY-130]);

set(handles.axes11,'Units','pixels');
set(handles.axes11,'Position',[300, 50, sizeX-350, sizeY-130]);


set(handles.axes4,'Position', [25, sizeY-125, 100, 100]);
set(handles.axes5,'Position', [150, sizeY-125, 100, 100]);
set(handles.axes10,'Position',[50, sizeY-300, 150, 150]);
set(handles.pushbutton1,'Position',[50, sizeY-425, 100, 25]);
set(handles.pushbutton2,'Position',[50, sizeY-475, 100, 25]);
set(handles.uipanel5,'Position',[50 sizeY-650, 150, 150]);
set(handles.text1,'Position',[300, sizeY-50, 300, 25]);
set(handles.closePredictionButton,'Position', [400, sizeY-75, 100, 25]);
set(handles.increaseImageSize,'Position',[650 sizeY-50, 75, 25]);
set(handles.resetImageSize,'Position',[750 sizeY-50, 75, 25]);
set(handles.decreaseImageSize,'Position',[850 sizeY-50, 75, 25]);
set(handles.infoTextSelectedCell,'Position',[50 sizeY-350, 100, 25]);
set(handles.selectedCellText,'Position',[150 sizeY-350, 50, 25]);
set(handles.posInfo,'Position',[50 sizeY-375, 50, 25]);
set(handles.editXCoord,'Position',[100 sizeY-375, 50, 25]);
set(handles.editYCoord,'Position',[150 sizeY-375, 50, 25]);

uData = get(handles.figure1,'UserData');
if uData.prediction == 1
    set(handles.closePredictionButton,'Visible','on');
    set(handles.toolbarTrainRegression,'Visible','off');
    set(handles.toolbarPredictWellPushtool,'Visible','off');
    set(handles.toolbarPredictPlatePushtool,'Visible','off');
    set(handles.ToolbarErrorVectors,'Visible','on');
else
    set(handles.closePredictionButton,'Visible','off');        
    set(handles.toolbarTrainRegression,'Visible','on');
    set(handles.toolbarPredictWellPushtool,'Visible','on');
    set(handles.toolbarPredictPlatePushtool,'Visible','on');
    set(handles.ToolbarErrorVectors,'Visible','off');
end


%This util function is plotting the navigation on which we can see where we
%are currently on the regression plane. (how much we're zoomed in etc.)
function plotNavigationMap(idx,uData)
global ghandles;
global CommonHandles;
XBounds = CommonHandles.RegressionPlane{idx}.XBounds;
YBounds = CommonHandles.RegressionPlane{idx}.YBounds;

cla(ghandles.axes10);
area(ghandles.axes10,[0 0 1000 1000 0],[0 1000 1000 0 0],'FaceColor','k','EdgeColor','k');
hold(ghandles.axes10,'on');

greenPositions = zeros(length(CommonHandles.TrainingSet.RegPos),2);
linesX = zeros(2,length(CommonHandles.TrainingSet.RegPos));
linesY = zeros(2,length(CommonHandles.TrainingSet.RegPos));

j = 1;
if uData.prediction==1
    bluePositions = (uData.predictedPositions)';
    if strcmp(get(ghandles.ToolbarErrorVectors,'State'),'on')
        for i=1:length(uData.predictedIcons)
            idxInTS = isInTrainingSet(uData.predictedIcons{i}.ImageName , uData.predictedIcons{i}.CellNumber, 0, CommonHandles);
            if ( idxInTS ~=0 && find(CommonHandles.TrainingSet.Class{idxInTS})==uData.lastRegressionPlaneIdx )
                greenPositions(j,:) = CommonHandles.TrainingSet.RegPos{idxInTS};
                linesX(:,j) = [CommonHandles.TrainingSet.RegPos{idxInTS}(1) ; uData.predictedPositions(1,i)];
                linesY(:,j) = [CommonHandles.TrainingSet.RegPos{idxInTS}(2) ; uData.predictedPositions(2,i)];
                j = j+1;
            end       
        end
        greenPositions(j:end,:) = [];
    end    
else
    %check if this is the first cell to place
    if isfield(CommonHandles.TrainingSet,'RegPos')    
        mergedClassVectors = reshape(cell2mat(CommonHandles.TrainingSet.Class),length(CommonHandles.Classes),[])';
        indicesInThisClass = find(mergedClassVectors(:,idx));
        if ~isempty(indicesInThisClass)
            %when placing new object it does not have position
            if indicesInThisClass(end)>length(CommonHandles.TrainingSet.RegPos)
                indicesInThisClass(end) = [];
            end
            %fill out array to plot
            greenPositions = cell2mat(CommonHandles.TrainingSet.RegPos(indicesInThisClass)');        

            if CommonHandles.RegressionPlane{idx}.selectedObject ~=0 && length(CommonHandles.TrainingSet.RegPos)>=CommonHandles.RegressionPlane{idx}.selectedObject
                redPosition = CommonHandles.TrainingSet.RegPos{CommonHandles.RegressionPlane{idx}.selectedObject};
            end
        end
    end
end

if exist('greenPositions','var') && ~isempty(greenPositions)
    plot(ghandles.axes10,greenPositions(:,1),greenPositions(:,2),'g*');
end
if exist('bluePositions','var') && ~isempty(bluePositions)
    plot(ghandles.axes10,bluePositions(:,1),bluePositions(:,2),'b*');
end
if exist('redPosition','var') && ~isempty(redPosition)
    plot(ghandles.axes10,redPosition(1),redPosition(2),'r*');
end
if exist('linesX','var') && ~isempty(linesX) && exist('linesY','var') && ~isempty(linesY)
    plot(ghandles.axes10,linesX,linesY,'w');
end

plot(ghandles.axes10,[XBounds(1) XBounds(1) XBounds(2) XBounds(2) XBounds(1)],[YBounds(1) YBounds(2) YBounds(2) YBounds(1) YBounds(1)],'w');
hold(ghandles.axes10,'off');

%This util function is more like a macro, it is used for shortening long
%conditions when we're examing whether a point is in the regression plane
%or not.
function bool = isInRegPlane(newPos, regPlaneBoundaries)
bool = newPos(1)>regPlaneBoundaries(1) && newPos(1)<regPlaneBoundaries(1)+regPlaneBoundaries(3) && newPos(2)> regPlaneBoundaries(2) && newPos(2) < regPlaneBoundaries(2) + regPlaneBoundaries(4);

    
% --- Executes when figure1 is resized.
function figure1_ResizeFcn(~,~, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

placeItemsOnGUI(handles);
drawRegressionPlane(handles);

% --- Executes on mouse press over axes background.
function axes1_ButtonDownFcn(~,~, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%global variables
global CommonHandles;
global ghandles;

uData = get(ghandles.figure1,'UserData');
idx = uData.classIndex;
idInTrainingSet = uData.idInTrainingSet;

CommonHandles.RegressionPlane{idx}.mapDragged = 0;

selType = get(gcf,'SelectionType');

switch selType
    case 'alt'                
        pos = get(gcf,'CurrentPoint');        

        if ~exist('handles','var')        
            handles = ghandles;
            regPlaneBoundaries = getpixelposition(handles.axes1);    
        else
            %Get the bounds of the axes1 which is the regression plane.
            regPlaneBoundaries = getpixelposition(handles.axes1);    
        end

        %Handle the out of bounds cases.
        if pos(1)<regPlaneBoundaries(1), pos(1) = regPlaneBoundaries(1); end
        if pos(1)>regPlaneBoundaries(1)+regPlaneBoundaries(3), pos(1) = regPlaneBoundaries(1)+regPlaneBoundaries(3); end
        if pos(2)<regPlaneBoundaries(2), pos(2) = regPlaneBoundaries(2); end
        if pos(2)>regPlaneBoundaries(2)+regPlaneBoundaries(4), pos(2) = regPlaneBoundaries(2)+regPlaneBoundaries(4); end

        distFromXLowerInGUI = pos(1) - regPlaneBoundaries(1);
        distFromYLowerInGUI = pos(2) - regPlaneBoundaries(2);

        
        pos = GUI2regPlane(pos);
                        
        if CommonHandles.RegressionPlane{idx}.newObject % if we're placing an object to the plane.
            CommonHandles.TrainingSet.RegPos{idInTrainingSet} = [pos(1) pos(2)];
            CommonHandles.RegressionPlane{idx}.newObject = 0;    
            prevGUI = gcbf;
            drawRegressionPlane(handles);
            CommonHandles.RegressionPlane{idx}.newObject = 0;
            plotNavigationMap(idx,uData);            
            uiresume(prevGUI);            
        else % if we want to select an object            
            CommonHandles.RegressionPlane{idx}.selectedObject = CommonHandles.RegressionPlane{idx}.whichObjectThere(regPlaneBoundaries(4)-distFromYLowerInGUI,distFromXLowerInGUI);                       
            refreshSelectedObjectPictures(idx,uData);                
            refreshSelectedObjectInfoData();
            drawRegressionPlane(handles);
            plotNavigationMap(idx,uData);
        end                
    case 'normal'
        CommonHandles.RegressionPlane{idx}.mapDragged = 1;
        CommonHandles.RegressionPlane{idx}.orPos = get(gcf,'CurrentPoint');
        set(gcf,'Pointer','fleur');
        disp(get(gcf,'Color'));
        plotNavigationMap(idx,uData);
end


% --- Executes on mouse motion over figure - except title and menu.
function figure1_WindowButtonMotionFcn(~,~, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)    
    global CommonHandles;
    newPos = get(gcf,'CurrentPoint');    
    regPlaneBoundaries = getpixelposition(handles.axes1);        
    
    uData = get(handles.figure1,'UserData');
    idx = uData.classIndex;
    orPos = CommonHandles.RegressionPlane{idx}.orPos;
    dragging = CommonHandles.RegressionPlane{idx}.dragging;
    XBounds = CommonHandles.RegressionPlane{idx}.XBounds;
    YBounds = CommonHandles.RegressionPlane{idx}.YBounds;
        
    if CommonHandles.RegressionPlane{idx}.mapDragged
        posDiff = newPos - orPos;
        %the magic number 10 is needed for unknown reason. Without this the
        %regression plane moves too fast.
        posXDiffRegPlane = posDiff(1)*(XBounds(2)-XBounds(1))./regPlaneBoundaries(3)./10;
        posYDiffRegPlane = posDiff(2)*(YBounds(2)-YBounds(1))./regPlaneBoundaries(4)./10;
        
        if max(XBounds - posXDiffRegPlane)<1000 && min(XBounds - posXDiffRegPlane)>0
            XBounds = XBounds - posXDiffRegPlane;        
        end
        if max(YBounds - posYDiffRegPlane)<1000 && min(YBounds - posYDiffRegPlane)>0
            YBounds = YBounds - posYDiffRegPlane;
        end                
        CommonHandles.RegressionPlane{idx}.XBounds = XBounds;
        CommonHandles.RegressionPlane{idx}.YBounds = YBounds;
        drawRegressionPlane(handles);        
    end
       
    if ~isempty(dragging)
        if newPos(1)>regPlaneBoundaries(1) && newPos(1)<regPlaneBoundaries(1)+regPlaneBoundaries(3) && newPos(2)> regPlaneBoundaries(2) && newPos(2) < regPlaneBoundaries(2) + regPlaneBoundaries(4)
              posDiff = newPos - orPos;
              orPos = newPos;              
              set(get(dragging,'Parent'),'Position',get(get(dragging,'Parent'),'Position') + [posDiff(1) posDiff(2) 0 0]);
        end
    end
    CommonHandles.RegressionPlane{idx}.orPos = orPos;         

% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.
function figure1_WindowButtonUpFcn(~,~, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

regPlaneBoundaries = getpixelposition(handles.axes1);    
uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

global CommonHandles;
selectedObject = CommonHandles.RegressionPlane{idx}.selectedObject;
CommonHandles.RegressionPlane{idx}.mapDragged = 0;
dragging = CommonHandles.RegressionPlane{idx}.dragging;
orPos = CommonHandles.RegressionPlane{idx}.orPos;


set(gcf,'Pointer','arrow');

if ~isempty(dragging)
    newPos = get(gcf,'CurrentPoint');
    %if we are on a valid point
    if isInRegPlane(newPos, regPlaneBoundaries);
        posDiff = newPos - orPos;
        set(get(dragging,'Parent'),'Position',get(get(dragging,'Parent'),'Position') + [posDiff(1) posDiff(2)  0 0]);
        
        newPos = GUI2regPlane(newPos);
        
        if (uData.prediction~=1)
            CommonHandles.TrainingSet.RegPos{selectedObject} = [newPos(1) newPos(2)];       
        else
            idxInTS = isInTrainingSet( uData.predictedIcons{selectedObject}.ImageName, uData.predictedIcons{selectedObject}.CellNumber, 0, CommonHandles);
            if idxInTS
                CommonHandles.TrainingSet.RegPos{idxInTS} = [newPos(1) newPos(2)];
                uData.predictedPositions(:,selectedObject) = [newPos(1); newPos(2)];
                set(handles.figure1,'UserData',uData);
            else
                
                %save CommonHandles info
                tempCurrentCellInfo.CellNumber = CommonHandles.SelectedCell;
                tempCurrentCellInfo.OriginalImageName = CommonHandles.SelectedOriginalImageName;
                tempCurrentCellInfo.ImageName = CommonHandles.SelectedImageName;
                tempCurrentCellInfo.PlateName = CommonHandles.SelectedPlate;
                
                %load data to CommonHandles fields           
                jumpToCell(uData.predictedIcons{selectedObject},0);
                %save the new cell to the training set classification related fields
                saveClassificationData(uData.lastRegressionPlaneIdx, uData.predictedIcons{selectedObject}.Features);
                %add the image to ClassImages
                addToClassImagesByObject(uData.predictedIcons{selectedObject});
                %add the new regressionPosition
                CommonHandles.TrainingSet.RegPos{end} = [newPos(1) newPos(2)];
                uData.predictedPositions(:,selectedObject) = [newPos(1); newPos(2)];
                set(handles.figure1,'UserData',uData);
                %load back the CommonHandles info
                jumpToCell(tempCurrentCellInfo,0);
                %refresh class icons and labels
                refreshClassesList();
                

            end
        end
        refreshSelectedObjectInfoData();
    else
        drawRegressionPlane(handles);
    end
    dragging = [];   
end
CommonHandles.RegressionPlane{idx}.dragging = dragging;
plotNavigationMap(idx,uData);


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, ~, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of checkbox1

global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

get(hObject,'Value')

CommonHandles.RegressionPlane{idx}.showGrid = CommonHandles.RegressionPlane{idx}.showGrid * -1;
drawRegressionPlane(handles);

% --- Executes on slider movement.
function slider2_Callback(hObject, ~, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

CommonHandles.RegressionPlane{idx}.gridDistance = get(hObject, 'Value');
set(handles.edit1,'String',num2str(get(hObject, 'Value')));
drawRegressionPlane(handles);


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, ~,~)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
set(hObject,'Min',1);
set(hObject,'Max',100);
set(hObject,'Value',10);


% --- Executes on button press in checkbox3.
function checkbox3_Callback(~,~, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox3
global CommonHandles;
uData = get(handles.figure1,'UserData');
idx = uData.classIndex;
CommonHandles.RegressionPlane{idx}.gridOnTheTop = CommonHandles.RegressionPlane{idx}.gridOnTheTop*-1;
drawRegressionPlane(handles);



function edit1_Callback(hObject, ~, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

global CommonHandles;
gridDistance = str2double(get(hObject,'String'));
if isnan(gridDistance)
    warndlg('The distance must be a number','Unexpected value');
    set(hObject,'String',10);
    set(handles.slider2,'Value',10);
elseif gridDistance<1 || gridDistance>100
    warndlg('The distance must be between 1 and 100','Unexpected value');
    set(hObject,'String',10);    
    set(handles.slider2,'Value',10);
else
    CommonHandles.RegressionPlane{idx}.gridDistance = gridDistance;
    drawRegressionPlane(handles);
    set(handles.slider2,'Value',gridDistance);
end


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, ~,~)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function uipushtool3_ClickedCallback(~,~, handles)
%Delete pushtool. It deletes the selected object
% hObject    handle to uipushtool3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

global CommonHandles;
selectedAxes = CommonHandles.RegressionPlane{idx}.selectedAxes;

if (exist('selectedAxes','var') && ~isempty(selectedAxes) && ishandle(selectedAxes))
    cla(selectedAxes);    
end

idInTS = CommonHandles.RegressionPlane{idx}.selectedObject;

deleteFromClassImages( CommonHandles.TrainingSet.CellNumber{idInTS}, CommonHandles.TrainingSet.ImageName{idInTS}, idx )
if ishandle(CommonHandles.ShowTrainedCellsFig)
    close(CommonHandles.ShowTrainedCellsFig);
end

CommonHandles.RegressionPlane{idx}.selectedObject = 0;
refreshSelectedObjectPictures(idx,uData);
drawRegressionPlane(handles);


% --------------------------------------------------------------------
function uipushtool4_ClickedCallback(~, ~, handles)
% hObject    handle to uipushtool4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% zoom out to overview tool

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

global CommonHandles;
CommonHandles.RegressionPlane{idx}.XBounds = [0 1000];
CommonHandles.RegressionPlane{idx}.YBounds = [0 1000];

if CommonHandles.RegressionPlane{idx}.adaptiveCellSize
    CommonHandles.RegressionPlane{idx}.apparentPictureSize = CommonHandles.RegressionPlane{idx}.startOfAdaptionCellSize;
end
   
drawRegressionPlane(handles);


% --- Executes on button press in increaseImageSize.
function increaseImageSize_Callback(~,~, handles)
% hObject    handle to increaseImageSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global CommonHandles;
uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

CommonHandles.RegressionPlane{idx}.apparentPictureSize = CommonHandles.RegressionPlane{idx}.apparentPictureSize*1.1;
drawRegressionPlane(handles);


% --- Executes on button press in decreaseImageSize.
function decreaseImageSize_Callback(~,~, handles)
% hObject    handle to decreaseImageSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

CommonHandles.RegressionPlane{idx}.apparentPictureSize = CommonHandles.RegressionPlane{idx}.apparentPictureSize/1.1;
drawRegressionPlane(handles);

% --- Executes on button press in resetImageSize.
function resetImageSize_Callback(~,~, handles)
% hObject    handle to resetImageSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;
CommonHandles.RegressionPlane{idx}.apparentPictureSize = CommonHandles.RegressionPlane{idx}.initialApparentPictureSize;
drawRegressionPlane(handles);


%Callback function for the X coordinate modification. We check the validity
%of the coordinate and move the selected object to the desired position.
function editXCoord_Callback(hObject, ~, handles)
% hObject    handle to editXCoord (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editXCoord as text
%        str2double(get(hObject,'String')) returns contents of editXCoord as a double

global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

if CommonHandles.RegressionPlane{idx}.selectedObject ~=0
    XCoord = str2double(get(hObject,'String'));
    if isnan(XCoord)
        warndlg('Coordinate must be number','Unexpected value');
        set(hObject,'String',num2str(CommonHandles.TrainingSet.RegPos{CommonHandles.RegressionPlane{idx}.selectedObject}(1)));
    elseif XCoord>1000 || XCoord <0
        warndlg('Coordinate must be between 0 and 1000','Unexpected value');
        set(hObject,'String',num2str(CommonHandles.TrainingSet.RegPos{CommonHandles.RegressionPlane{idx}.selectedObject}(1)));
    else
        CommonHandles.TrainingSet.RegPos{CommonHandles.RegressionPlane{idx}.selectedObject}(1) = XCoord;
        drawRegressionPlane(handles);
    end
end


% --- Executes during object creation, after setting all properties.
function editXCoord_CreateFcn(hObject, ~,~)
% hObject    handle to editXCoord (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editYCoord_Callback(hObject, ~, handles)
% hObject    handle to editYCoord (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editYCoord as text
%        str2double(get(hObject,'String')) returns contents of editYCoord as a double
global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

if CommonHandles.RegressionPlane{idx}.selectedObject ~=0
    YCoord = str2double(get(hObject,'String'));
    if isnan(YCoord)
        warndlg('Coordinate must be number','Unexpected value');
        set(hObject,'String',num2str(CommonHandles.TrainingSet.RegPos{CommonHandles.RegressionPlane{idx}.selectedObject}(2)));
    elseif YCoord>1000 || YCoord <0
        warndlg('Coordinate must be between 0 and 1000','Unexpected value');
        set(hObject,'String',num2str(CommonHandles.TrainingSet.RegPos{CommonHandles.RegressionPlane{idx}.selectedObject}(2)));
    else
        CommonHandles.TrainingSet.RegPos{CommonHandles.RegressionPlane{idx}.selectedObject}(2) = YCoord;
        drawRegressionPlane(handles);
    end
end




% --- Executes during object creation, after setting all properties.
function editYCoord_CreateFcn(hObject, ~,~)
% hObject    handle to editYCoord (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --------------------------------------------------------------------
function adaptiveCellSize_OnCallback(~,~,handles)
% hObject    handle to adaptiveCellSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

CommonHandles.RegressionPlane{idx}.adaptiveCellSize = 1;
CommonHandles.RegressionPlane{idx}.startOfAdaptionCellSize = CommonHandles.RegressionPlane{idx}.apparentPictureSize;



% --------------------------------------------------------------------
function adaptiveCellSize_OffCallback(~,~,handles)
% hObject    handle to adaptiveCellSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;


CommonHandles.RegressionPlane{idx}.adaptiveCellSize = 0;


% --------------------------------------------------------------------
function toolbarTrainRegression_ClickedCallback(~, ~, handles)
% hObject    handle to toolbarTrainRegression (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;
trainRegression_GUI('UserData',struct('classIndex',idx));


% --------------------------------------------------------------------
function toolbarPredictWellPushtool_ClickedCallback(~, ~, handles)
% hObject    handle to toolbarPredictWellPushtool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global CommonHandles;

uData = get(handles.figure1,'UserData');
idx = uData.classIndex;

%check for the existance of the predictor
if isfield(CommonHandles.RegressionPlane{idx},'Predictor')   

    
    selectedAxes = CommonHandles.RegressionPlane{idx}.selectedAxes;
    if ~isempty(selectedAxes) && ishandle(selectedAxes)
        cla(selectedAxes);
        CommonHandles.RegressionPlane{idx}.selectedAxes = [];
    end
    set(handles.toolbarTrainRegression,'Visible','off');
    set(handles.toolbarPredictWellPushtool,'Visible','off');
    set(handles.toolbarPredictPlatePushtool,'Visible','off');
    set(handles.ToolbarErrorVectors,'Visible','on');
    
    %build up GUI to select the images to predict on the regression plane
    ImagesByPlate = cell(1,length(CommonHandles.PlatesNames));
    for i=1:length(CommonHandles.PlatesNames)
         listedDir = dir([CommonHandles.DirName filesep CommonHandles.PlatesNames{i} filesep CommonHandles.ImageFolder]);
         ImagesByPlate{i} = char(listedDir(3:end).name);
    end
    
    ImageListStr = cell2mat(ImagesByPlate');
    
    [SelectedImages,isOK] = listdlg('PromptString','Select plate(s):', 'Name', 'Add plates', 'SelectionMode','multiple','ListString', ImageListStr);
    
    if isOK && ~isempty(SelectedImages)

        %Save the current cell infos.
        tempCurrentCellInfo.CellNumber = CommonHandles.SelectedCell;
        tempCurrentCellInfo.OriginalImageName = CommonHandles.SelectedOriginalImageName;
        tempCurrentCellInfo.ImageName = CommonHandles.SelectedImageName;
        tempCurrentCellInfo.PlateName = CommonHandles.SelectedPlate;
        
        iconsByImage = cell(1,length(SelectedImages));
        positionsByImage = cell(1,length(SelectedImages));
        for i=convert2RowVector(SelectedImages)                        
            [~, fileNameexEx, ~] = fileparts(ImageListStr(i,:));
            splittedImagePath = strsplit(ImageListStr(i,:),{'_'});
            plateName = splittedImagePath{1};
            plateNumber = getPlateNumberByName(plateName);
            %read features to know the amount of cells to iterate through
            [~,features] = readMetaData(CommonHandles,fileNameexEx,plateNumber);            
            
            %collect images if there are any
            if ~((size(features,1) == 1 || size(features,2) == 1) && (isequal(zeros(size(features)),features)))
       
                %check for the existance of the SALT model. If not, then we train a
                %model.
                screensize = get(0,'Screensize');
                if ~isfield(CommonHandles.SALT,'model') || isempty(CommonHandles.SALT.model)                                        
                    iD = dialog('Name','Missing classifer','Position',[screensize(3)/2-180, screensize(4)/2-30,360,60]);
                    uicontrol('Parent',iD,'Style','text','Units','Pixels','Position',[10 20 340 20],'String','Train a classifier...');
                    CommonHandles = trainClassifier(CommonHandles);                   
                    if ishandle(iD)
                        close(iD);
                    end
                end

                if isfield(CommonHandles.SALT,'model') && ~isempty(CommonHandles.SALT.model)
                    [ out, ~, ~ ] = predictClassifier( features(:,3:end) , CommonHandles);
                    %select cells classified to regression class.           
                    features = features(out==idx,:);
                    regressionCellIdx = find(out==idx);
                    
                    icons = cell(1,size(features,1));
                    features = features(:,3:end);
                    for j=1:size(features,1)
                        cellInfoStruct.PlateName = plateNumber;
                        cellInfoStruct.ImageName = [plateName filesep CommonHandles.ImageFolder filesep ImageListStr(i,:)];
                        cellInfoStruct.OriginalImageName = [plateName filesep CommonHandles.OriginalImageFolder filesep ImageListStr(i,:) ];
                        cellInfoStruct.CellNumber = regressionCellIdx(j);
                        jumpToCell(cellInfoStruct,0);
                        classImgObj.Image = CommonHandles.CurrentSelectedCell;
                        classImgObj.ClassName = CommonHandles.Classes{idx}.Name;
                        classImgObj.CellNumber = regressionCellIdx(j);
                        classImgObj.ImageName = cellInfoStruct.ImageName;
                        classImgObj.OriginalImageName = cellInfoStruct.OriginalImageName;
                        classImgObj.PlateName = plateNumber;
                        classImgObj.Features = features(j,:);
                        icons{j} = classImgObj;
                    end
                    iconsByImage{i} = icons;
                    %features transposed because predictors waiting for column
                    %observation
                    positions = CommonHandles.RegressionPlane{idx}.Predictor.predict(features');
                    positionsByImage{i} = positions;
                    
                else
                    warndlg('Couldn''t train classifier.','Classifier error');
                end
                
            end
        end
        
        predictedIcons = [iconsByImage{:}];
        predictedPositions = [positionsByImage{:}];
        
        %jump back to the original cell after collecting the images to put
        %on regplane.
        jumpToCell(tempCurrentCellInfo,0);
        
        %Make poster       
        %makePoster(predictedIcons,predictedPositions,[10,10]);
        
        CommonHandles.RegressionPlaneHandle = regressionPlane('UserData',struct('idInTrainingSet',0,'classIndex',length(CommonHandles.RegressionPlane)+1,'prediction',1,'predictedIcons',{predictedIcons},'predictedPositions',predictedPositions,'lastRegressionPlaneIdx',idx) );
    else
        set(handles.toolbarTrainRegression,'Visible','on');
        set(handles.toolbarPredictWellPushtool,'Visible','on');
        set(handles.toolbarPredictPlatePushtool,'Visible','on');
        set(handles.ToolbarErrorVectors,'Visible','off');
        set(handles.ToolbarErrorVectors,'State','off');
        ToolbarErrorVectors_OffCallback(handles.ToolbarErrorVectors, 0, handles);
    end
    
else
    warndlg('Please train a predictor before using prediction!','Trained predictor is missing');
end

% --- Executes on button press in closePredictionButton.
function closePredictionButton_Callback(~, ~, handles)
% hObject    handle to closePredictionButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global CommonHandles;
uData = get(handles.figure1,'UserData');
lastIndex = uData.lastRegressionPlaneIdx;

idx = uData.classIndex;
if ishandle(CommonHandles.RegressionPlane{idx}.selectedAxes)
    cla(CommonHandles.RegressionPlane{idx}.selectedAxes);
end

set(handles.toolbarTrainRegression,'Visible','on');
set(handles.toolbarPredictWellPushtool,'Visible','on');
set(handles.toolbarPredictPlatePushtool,'Visible','on');
set(handles.ToolbarErrorVectors,'Visible','off');
set(handles.ToolbarErrorVectors,'State','off');
ToolbarErrorVectors_OffCallback(handles.ToolbarErrorVectors, 0, handles);
CommonHandles.RegressionPlaneHandle = regressionPlane('UserData',struct('idInTrainingSet',0,'classIndex',lastIndex,'prediction',-1));
CommonHandles.RegressionPlane(end) = [];


% --------------------------------------------------------------------
function toolbarPredictPlatePushtool_ClickedCallback(~, ~, handles)
% hObject    handle to toolbarPredictPlatePushtool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

uData = get(handles.figure1,'UserData');

predictRegression_GUI('UserData',uData);


% --------------------------------------------------------------------
function ToolbarErrorVectors_OffCallback(~, ~, handles)
% hObject    handle to ToolbarErrorVectors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global ghandles;
ghandles = handles;

drawRegressionPlane(handles);

% --------------------------------------------------------------------
function ToolbarErrorVectors_OnCallback(~, ~, handles)
% hObject    handle to ToolbarErrorVectors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global ghandles;
ghandles = handles;

drawRegressionPlane(handles);