function deleteFromTrainingSet( idx )
% AUTHOR:   Abel Szkalisity
% DATE:     Sept 10, 2016
% NAME:     deleteFromTrainingSet
%
% To delete instance from the training set. This function only removes all
% corresponding entries from CommonHandles.TrainingSet fields. It does NOT
% deletes classImages.
%
% INPUT:
%   idx             Index of instance within TrainingSet to delete
%
%   CommonHandles   global input-output
%
% COPYRIGHT
% Advanced Cell Classifier (ACC) Toolbox. All rights reserved.
% Copyright (C) 2016 Peter Horvath,
% Synthetic and System Biology Unit, Hungarian Academy of Sciences,
% Biological Research Center, Szeged, Hungary; Institute for Molecular
% Medicine Finland, University of Helsinki, Helsinki, Finland.

global CommonHandles;

CommonHandles.TrainingSet.MetaDataFilename(idx) = [];
CommonHandles.TrainingSet.ImageName(idx) = [];
CommonHandles.TrainingSet.OriginalImageName(idx) = [];
CommonHandles.TrainingSet.CellNumber(idx) = [];
CommonHandles.TrainingSet.Features(idx) = [];
CommonHandles.TrainingSet.Class(idx) = [];
CommonHandles.TrainingSet.Timestamp(idx) = [];
CommonHandles.TrainingSet.RegPos(idx) = [];



end

