function removePlate(plateNumber)
% AUTHOR:	Tamas Balassa
% DATE: 	June 17, 2016
% NAME: 	removePlate
% 
% To remove one plate from the dataset
%
% INPUT:
%        plateNumber         The number of the plate that will be removed
%
%
% COPYRIGHT
% Advanced Cell Classifier (ACC) Toolbox. All rights reserved.
% Copyright (C) 2016 Peter Horvath,
% Synthetic and System Biology Unit, Hungarian Academia of Sciences,
% Biological Research Center, Szeged, Hungary; Institute for Molecular
% Medicine Finland, University of Helsinki, Helsinki, Finland.

    global CommonHandles;
    
    % update plates in AllFeaturesMapping
    if isfield(CommonHandles,'AllFeaturesMapping') && ~isempty(CommonHandles.AllFeaturesMapping)
       for i=1:size(CommonHandles.AllFeaturesMapping,2)
           if CommonHandles.AllFeaturesMapping{i}.CurrentPlateNumber == plateNumber
               CommonHandles.AllFeaturesMapping{i}.CurrentPlateNumber = 0;
           elseif CommonHandles.AllFeaturesMapping{i}.CurrentPlateNumber > plateNumber
               CommonHandles.AllFeaturesMapping{i}.CurrentPlateNumber = CommonHandles.AllFeaturesMapping{i}.CurrentPlateNumber - 1;
           end
       end
    end
    
    % update plates in ClassImages
    if CommonHandles.ClassImages.Count == size(CommonHandles.Classes,2)
        for i=1:size(CommonHandles.Classes,2)
            classImgs = CommonHandles.ClassImages(CommonHandles.Classes{i}.Name);
            imgs = CommonHandles.ClassImages(CommonHandles.Classes{i}.Name).Images;
            for j=1:size(imgs,2)
                if imgs{j}.PlateName == plateNumber
                    imgs{j}.PlateName = 0;
                elseif imgs{j}.PlateName > plateNumber
                    imgs{j}.PlateName = imgs{j}.PlateName - 1;
                end
            end
            classImgs.Images = imgs;
            CommonHandles.ClassImages(CommonHandles.Classes{i}.Name) = classImgs;
        end
    end
    
    % remove the plate from the plates
    CommonHandles.PlatesNames = setdiff(CommonHandles.PlatesNames, CommonHandles.PlatesNames(plateNumber));